import sys
import re
import gspread
import json
from oauth2client.service_account import ServiceAccountCredentials

def connect_gspread(jsonf,key):
    scope = ['https://spreadsheets.google.com/feeds','https://www.googleapis.com/auth/drive']
    credentials = ServiceAccountCredentials.from_json_keyfile_name(jsonf, scope)
    gc = gspread.authorize(credentials)
    SPREADSHEET_KEY = key
    worksheet = gc.open_by_key(SPREADSHEET_KEY).sheet1
    return worksheet

jsonf = "json/project-run-summary-e411fb11bcf9.json"
spread_sheet_key = "1jIoGg3r5ZYtU9enfzA5iV45d7WRtI2jc94a0XOy9Ayc"
ws = connect_gspread(jsonf,spread_sheet_key)


args = sys.argv

#print(args)
#for i, arg in enumerate(args) :
#	print(i," : ",arg)

run_name = args[4]
run_number = args[8]

start = args[12]
stop = args[16]
date = args[19]
header = ""
header_i, header_f = 0,0
ender = ""
ender_i, ender_f = 0,0

scaler = []

for i, arg in enumerate(args) :
	if arg == "Header" :
		header_i = i + 2
	if arg == "Ender" :
		header_f = i
		ender_i = i + 2
	if re.match('SCR(\d+)', arg ) :
		scaler.append(args[i+1])
		if ender_f == 0 :
			ender_f = i


#print(header_i, header_f)
#print(ender_i, ender_f)

header = args[header_i:header_f]
ender = args[ender_i:ender_f]

print("RUN NAME = ", run_name)
print("RUN NUMBER = ", run_number)
print("Start : ", start)
print("Stop  : ", stop)
print("Date  : ", date)
print("HEADER  : ", ' '.join(header))
print("ENDER  : ", ' '.join(ender))
print("Scaler: ", scaler)

run_number_int = int(run_number)

ds = ws.range('B'+str(run_number_int*9-3)+':R'+str(run_number_int*9+4))
# 7 * 17 = 119
ds[0].value = run_name
ds[1].value = run_number
ds[2].value = date
ds[3].value = start
ds[4].value = stop
ds[5].value = ' '.join(header)
ds[6].value = ' '.join(ender)

for i in range(34) :
	l = 8+int(i/5.0)*17+i%5*2
	m = i%5*7+int(i/5.0)
	if m < 32 : 
		ds[l].value = scaler[m]
# for i in range(32) :
# 	ds[65+int(i/7.0)*8+i].value = scaler[i]

ws.update_cells(ds)

